#include "StdAfx.h"
#include "PeriodicEventHandler.h"
#include "NeMessengerDlg.h"
#include "TlHelp32.h"

#define MAX_LOGIN_INTERVAL 3000

CPeriodicEventHandler::CPeriodicEventHandler(CNeMessengerDlg* pDlg)
	:m_bScreenSaverActivated(FALSE)
{
	m_pMessengerDlg = pDlg;
    m_nPort = 0;
	WSTRING strServerAddr = g_pMessengerActor->GetWASActor()->GetWASServerAddress();
	AfxParseURL(strServerAddr.c_str(), m_dwServiceType, m_strServerName, m_strObject, m_nPort);
}

CPeriodicEventHandler::~CPeriodicEventHandler(void)
{
}


void CPeriodicEventHandler::run()
{
	UINT nAgentCheck = 0;
	while(1)
	{
		DoCheckScreenSaverStatus();

		if (nAgentCheck > 900 * 2)
		{
			DoCheckUpdateAgent();
			nAgentCheck = 0;
		}

		++nAgentCheck;

		Sleep(500);
	}
}

BOOL CPeriodicEventHandler::CheckNetworkStatus()
{
	if( false == m_pMessengerDlg->IsLogin() )
		return TRUE;

	CHttpConnection* pServer = NULL; 
	CHttpFile *pFile = NULL;
	BOOL bRet = FALSE;
	DWORD dwRet;
	DWORD dwHttpRequestFlags = INTERNET_FLAG_RELOAD | INTERNET_FLAG_DONT_CACHE | INTERNET_FLAG_NO_AUTO_REDIRECT;
	CInternetSession session(L"NTalkBiz Ping"); 

	try 
	{ 
		session.SetOption(INTERNET_OPTION_CONNECT_TIMEOUT, 5000);
		session.SetOption(INTERNET_OPTION_SEND_TIMEOUT, 5000);
		session.SetOption(INTERNET_OPTION_RECEIVE_TIMEOUT, 5000);

		pServer = session.GetHttpConnection(m_strServerName, m_nPort);
		if (NULL == pServer)
		{
			goto ReleaseAndReturn;
		}

		pFile = pServer->OpenRequest(CHttpConnection::HTTP_VERB_GET, m_strObject, NULL, 1, NULL, NULL, dwHttpRequestFlags);
		if (NULL == pFile)
		{
			goto ReleaseAndReturn;
		}

		pFile->SendRequest(); 

		pFile->QueryInfoStatusCode(dwRet);
		if(HTTP_STATUS_NOT_FOUND != dwRet) 
		{		
			bRet = TRUE;
		} 
	} 
	catch (CInternetException* pEx) 
	{ 
		TRACE("%s %d\n", __FUNCTION__, __LINE__);
		pEx->Delete();
	}

ReleaseAndReturn:

	if(pFile)
	{
		pFile->Close(); 
		delete pFile;
		pFile = NULL;
	}

	if(pServer)
	{
		pServer->Close(); 
		delete pServer;
		pServer = NULL;
	} 

	session.Close(); 
	return bRet;
}

BOOL CPeriodicEventHandler::IsScreenSaverStatus()
{
	BOOL bSaver;
	if (::SystemParametersInfo (SPI_GETSCREENSAVERRUNNING,0,&bSaver,0))
	{
		return bSaver;
	}

	return FALSE;
}

void CPeriodicEventHandler::DoCheckScreenSaverStatus()
{
	if (NULL == m_pMessengerDlg)
		return;

	if( false == m_pMessengerDlg->IsLogin() )
		return;

	if (FALSE == m_bScreenSaverActivated
		&& TRUE == IsScreenSaverStatus())
	{
		m_pMessengerDlg->AdjustUserStatus(WTS_SESSION_LOCK);
		m_bScreenSaverActivated = TRUE;
	}
	else if (TRUE == m_bScreenSaverActivated 
		&& FALSE == IsScreenSaverStatus())
	{
			m_pMessengerDlg->AdjustUserStatus(WTS_SESSION_UNLOCK);
			m_bScreenSaverActivated = FALSE;
	}
}

void CPeriodicEventHandler::DoCheckUpdateAgent()
{
	const TCHAR UPGRADE_LAUNCHER_GUID[] = _T("EE77F315-BA0A-4ec2-A88F-3A0D6121B831");
	BOOL bResult = FALSE;
	PROCESSENTRY32 entry; 
	entry.dwSize = sizeof(PROCESSENTRY32); 
	CString processName(_T("NtalkbizUpgrader.exe")); 

	HANDLE snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, NULL); 

	if (Process32First(snapshot, &entry) == TRUE) 
	{ 
		while (Process32Next(snapshot, &entry) == TRUE) 
		{ 
			if (processName.CompareNoCase(entry.szExeFile) == 0) 
			{
				bResult = TRUE;
				break;
			}
		} 
	} 

	CloseHandle(snapshot);

	if (FALSE == bResult)
	{
		//agnet Ʈ ǰ ִ ¶   ʴ´.
		BOOL bRestartUpdaterAgnet = TRUE;

		HANDLE handle = ::CreateMutex( NULL, TRUE, UPGRADE_LAUNCHER_GUID );
		if (NULL != handle)
		{
			if (GetLastError() == ERROR_ALREADY_EXISTS)
			{
				bRestartUpdaterAgnet = FALSE;
			}

			ReleaseMutex(handle);
			CloseHandle(handle);
		}

		if (TRUE == bRestartUpdaterAgnet)
		{	
			CString strRootPath;	
			strRootPath.AppendFormat(_T("%s\\Update\\NtalkbizUpgrader.exe"), GetNtalkModulePath());			

			ShellExecute(NULL, NULL, strRootPath, _T(""), NULL, SW_SHOWNORMAL);
		}
	}
}
